/*  -*- c -*-
   $RCSfile: canvasdot.h,v $
   $Revision: 1.2 $
   $Author: reida $
   $Date: 2003/04/02 14:51:54 $  */

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

/* Custom canvas item, draws a circle on the canvas whose 
   radius can be specified in pixels.  For some strange reason,
   the rectangle/ellipse functions of the stock canvas do not do this. 
   This item is a subclass of the GtkCanvasRE. */

/* Parameters:
   x               double     read/write   x-coord of center of dot
   y               double     read/write   y-coord of center of dot
   size            uint       read/write   size (radius) of dot in pixels. */

/* Fill color, stipple, graphics context, and so forth are set 
   from the parent class.  The parent class's outline parameters
   are ignored. */

#ifndef CANVASDOT_H
#define CANVASDOT_H

/* This include retrieves just about everything needed. */
#include <gtk-canvas/gtk-canvas-rect-ellipse.h>

BEGIN_GTK_CANVAS_DECLS


#define GTK_CANVAS_TYPE_CANVAS_DOT     (gtk_canvas_dot_get_type ())
#define GTK_CANVAS_DOT(obj)    (GTK_CHECK_CAST((obj), GTK_CANVAS_TYPE_CANVAS_DOT, GtkCanvasDot))
#define GTK_CANVAS_DOT_CLASS(klass) (GTK_CHECK_CLASS_CAST((klass, GTK_CANVAS_TYPE_CANVAS_DOT, GtkCanvasDot))
#define GTK_CANVAS_IS_CANVAS_DOT(obj) (GTK_CHECK_TYPE((obj), GTK_CANVAS_TYPE_CANVAS_DOT))
#define GTK_CANVAS_IS_CANVAS_DOT_CLASS(klass) (GTK_CHECK_CLASS_TYPE((klass), GTK_CANVAS_TYPE_CANVAS_DOT))
						

typedef struct _GtkCanvasDot      GtkCanvasDot;
typedef struct _GtkCanvasDotClass GtkCanvasDotClass;


struct _GtkCanvasDot {
  GtkCanvasRE re;  

  double x, y;
  int size;

};

struct _GtkCanvasDotClass {
  GtkCanvasREClass parent_class;
};

/* Standard Gtk function */
GtkType gtk_canvas_dot_get_type(void);

END_GTK_CANVAS_DECLS

#endif /* CANVASDOT_H */
