// -*- C++ -*-
// $RCSfile: forcedensity.h,v $
// $Revision: 1.1 $
// $Author: redwing $
// $Date: 2005/03/22 18:14:26 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#ifndef FORCEDENSITY_H
#define FORCEDENSITY_H

#include "engine/property.h"
#include <string>

class Cijkl;
class Element;
class Flux;
class Material;
class FEMesh;
class Position;
class TwoVectorField;
class SymmetricTensorFlux;
class ElementNodeIterator;

class ForceDensity : public Property {
private:
  double gx, gy, gz;
public:
  ForceDensity(PyObject *reg, const std::string &name, double x, double y, double z);
  virtual ~ForceDensity() {}
  virtual void precompute();
  virtual void fluxrhs(const FEMesh*, const Element*, const Flux*, FluxData*,
		       const MasterPosition&) const;
  virtual int K_integration_order(int) const;
  double fdensity_x() const { return gx; }
  double fdensity_y() const { return gy; }
  double fdensity_z() const { return gz; }
  virtual int is_symmetric(const FEMesh*) const {return 1;}
protected:
  TwoVectorField *displacement;
  SymmetricTensorFlux *stress_flux;
};

#endif
