# -*- python -*-
# $RCSfile: skeletonrelaxationrate_.py,v $
# $Revision: 1.5 $
# $Author: langer $
# $Date: 2005/05/13 18:44:19 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from oof2.SWIG.common import devel
from oof2.SWIG.engine import symmmatrix
from oof2.common import utils
from oof2.common.IO import parameter
from oof2.engine import problem
from oof2.engine import propertyregistration

PropertyRegistration = propertyregistration.PropertyRegistration

SkeletonRelaxationRateTensor = PropertyRegistration(
    'SkeletonRelaxationRate', SkeletonRelaxationRate,
    "oof2.SWIG.engine.property.skeletonrelaxationrate.skeletonrelaxationrate",9000,
    [parameter.FloatParameter('alpha', 1,), # force prefactor
     parameter.FloatParameter('beta', 0.5)], # relative weight of shape & homog.
    fields=[problem.Displacement],
    fluxes=[problem.Stress],
    outputs=[],
    propertyType="SkeletonRelaxationRate",
    nonlinear=1,
    secret = 1)
    

# Property reprs refer to the registered name, not the actual class name.
def _SkeletonRelaxationRate___repr__(self):
    return "SkeletonRelaxationRate(name='%s', alpha=%s)" % \
           (self.name(), `self.alpha()`)

SkeletonRelaxationRatePtr.__repr__ = _SkeletonRelaxationRate___repr__
