// -*- C++ -*-
// $RCSfile: subproblem.C,v $
// $Revision: 1.6 $
// $Author: redwing $
// $Date: 2005/06/16 15:20:49 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>
#include <vector>
#include "engine/subproblem.h"
#include "engine/femesh.h"

SubProblem::~SubProblem()
{
  delete freedofmap;
  if (forward_mapping)
    delete forward_mapping;
}

void SubProblem::set_freedofmap(const FEMesh *femesh) //std::vector<int> *fdofmap)
{
  const std::vector<int> &fdofmap = femesh->freedofmap;
  if (freedofmap == 0)
    {
      freedofmap = new std::vector<int> (fdofmap.size(), 0);
      (*freedofmap) = fdofmap; //transfer contents
    }
}

void SubProblem::set_forward_mapping(const std::vector<int> *fmap)
{
  forward_mapping = new std::vector<int> (fmap->size(), 0);
  (*forward_mapping) = (*fmap); //transfer contents

}


void SubProblem::set_prev_solution( VECTOR_D *x_maybe)
{
  if (x_prev == 0)
    {
      x_prev = new VECTOR_D(x_maybe->size(), 0.0);
    }
  else
    {
      if (x_prev->size() != x_maybe->size())
	x_prev->newsize(x_maybe->size());
    }
  (*x_prev) = (*x_maybe);

}
