# -*- python -*-
# $RCSfile: menuGUI.py,v $
# $Revision: 1.9 $
# $Author: langer $
# $Date: 2005/05/13 18:44:22 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# Add GUI callbacks to menus.


from oof2.SWIG.common import ooferror
from oof2.common.IO import mainmenu
from oof2.common.IO.GUI import fileselector
from oof2.common import microstructure

def _loadImage(menuitem):
    msparam = menuitem.get_arg('microstructure')
    wparam = menuitem.get_arg('width')
    hparam = menuitem.get_arg('height')
    file = fileselector.fileSelector(ident='Image', title='Load Image',
                                     params=(msparam, wparam, hparam))
    if file is None:
        return
    if not msparam.value:
        raise ooferror.ErrUserError(
            "You must specify a Microstructure for the Image.")
    menuitem(filename=file, microstructure=msparam.value, width=wparam.value,
             height=hparam.value)

mainmenu.OOF.File.Load.Image.add_gui_callback(_loadImage)

